package fi.em.formPlugin;

import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.field.TextEdit;
import kd.bos.form.operate.AbstractOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;

import java.util.EventObject;

/**
 * @author cjz
 * @date 2024/11/11 14:49
 * @description:薪酬发放单弹窗选择计提单数据
 */
public class SalaryDataSelectPlugin extends AbstractFormPlugin {


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 对选择计提单按钮添加点击监听
        TextEdit textEdit = getControl("nckd_selectdata");
        textEdit.addClickListener(this);
    }



    @Override
    public void click(EventObject evt) {
        Control control = (Control) evt.getSource();
        String key = control.getKey();
        //点击计提单数据库选择
        if (StringUtils.equalsIgnoreCase("nckd_selectdata", key)) {
            //薪酬计提数据
            ListShowParameter parameter = ShowFormHelper.createShowListForm("nckd_salarydis", false);
            parameter.getListFilterParameter().setOrderBy("nckd_bizdate Desc");
            getView().showForm(parameter);
        }
        super.click(evt);
    }




}
