package fi.em.opplugin;

import fi.cas.opplugin.PayBillToolUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * @author cjz
 * @date 2024/8/28 16:22
 * @description:代发处理单，点击关闭付款，付款给前置，修改支付状态
 */
public class AgentpaybillOpPlugin extends AbstractOperationServicePlugIn {

    //关闭付款按钮标识
    private static String closepay="payclose";
    //付款给前置按钮标识
    private static String payforfront="payforfront";




    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        String operationKey = e.getOperationKey();
        //关闭付款则将支付状态更改为支付关闭状态
        if (closepay.equals(operationKey)){
            for (int i=0;i< dynamicObjects.length;i++) {
                //设置支付状态为
                dynamicObjects[i].set("nckd_paystatus","D");
            }
            SaveServiceHelper.save(dynamicObjects);
        }else if (payforfront.equals(operationKey)){
            String errMsg = "";
            errMsg =  PayBillToolUtil.agentpayBillForCBSSync(dynamicObjects);
            if(!errMsg.isEmpty()) {
                //将成功错误信息返回到前端
                e.setCancelMessage(errMsg);
                e.setCancel(true);
            }
        }else if ("payzx".equals(operationKey)){
            String errMsg = "";
            errMsg =  PayBillToolUtil.agentpayzx(dynamicObjects);
            if(!errMsg.isEmpty()) {
                //将成功错误信息返回到前端
                e.setCancelMessage(errMsg);
                e.setCancel(true);
            }
        }else if ("repaytozfqz".equals(operationKey)){
            String errMsg = "";
            errMsg =  PayBillToolUtil.repaytozfqz(dynamicObjects);
            if(!errMsg.isEmpty()) {
                //将成功错误信息返回到前端
                e.setCancelMessage(errMsg);
                e.setCancel(true);
            }
        }else if ("payclose".equals(operationKey)){
            String errMsg = "";
            errMsg =  PayBillToolUtil.payclose(dynamicObjects);
            if(!errMsg.isEmpty()) {
                //将成功错误信息返回到前端
                e.setCancelMessage(errMsg);
                e.setCancel(true);
            }
        }
    }

}
